// This file is generated by kconfig_compiler_kf6 from config.kcfg.
// All changes you do to this file will be lost.
#ifndef PLASMATUBESETTINGS_H
#define PLASMATUBESETTINGS_H

#include <qglobal.h>
#include <kconfigskeleton.h>
#include <QCoreApplication>
#include <QDebug>

class PlasmaTubeSettings : public KConfigSkeleton
{
  Q_OBJECT
  public:
    class EnumProxyType
    {
      public:
      enum type { System, HTTP, COUNT };
    };

    PlasmaTubeSettings( KSharedConfig::Ptr config = KSharedConfig::openConfig(), QObject *parent = nullptr );
    ~PlasmaTubeSettings() override;

    /**
      Set The type of proxy used by the application.
    */
    void setProxyType( int v )
    {
      if (v != mProxyType && !isProxyTypeImmutable()) {
        mProxyType = v;
        Q_EMIT ProxyTypeChanged();
      }
    }

    Q_PROPERTY(int proxyType READ proxyType WRITE setProxyType NOTIFY ProxyTypeChanged)
    Q_PROPERTY(bool isProxyTypeImmutable READ isProxyTypeImmutable CONSTANT)
    /**
      Get The type of proxy used by the application.
    */
    int proxyType() const
    {
      return mProxyType;
    }

    /**
      Is The type of proxy used by the application. Immutable
    */
    bool isProxyTypeImmutable() const
    {
      return isImmutable( QStringLiteral( "ProxyType" ) );
    }

    /**
      Get The type of proxy used by the application. default value
    */
    int defaultProxyTypeValue() const
    {
        return defaultProxyTypeValue_helper();
    }

    /**
      Set IP or hostname of the proxy
    */
    void setProxyHost( const QString & v )
    {
      if (v != mProxyHost && !isProxyHostImmutable()) {
        mProxyHost = v;
        Q_EMIT ProxyHostChanged();
      }
    }

    Q_PROPERTY(QString proxyHost READ proxyHost WRITE setProxyHost NOTIFY ProxyHostChanged)
    Q_PROPERTY(bool isProxyHostImmutable READ isProxyHostImmutable CONSTANT)
    /**
      Get IP or hostname of the proxy
    */
    QString proxyHost() const
    {
      return mProxyHost;
    }

    /**
      Is IP or hostname of the proxy Immutable
    */
    bool isProxyHostImmutable() const
    {
      return isImmutable( QStringLiteral( "ProxyHost" ) );
    }

    /**
      Get IP or hostname of the proxy default value
    */
    QString defaultProxyHostValue() const
    {
        return defaultProxyHostValue_helper();
    }

    /**
      Set The port number of the proxy
    */
    void setProxyPort( int v )
    {
      if (v != mProxyPort && !isProxyPortImmutable()) {
        mProxyPort = v;
        Q_EMIT ProxyPortChanged();
      }
    }

    Q_PROPERTY(int proxyPort READ proxyPort WRITE setProxyPort NOTIFY ProxyPortChanged)
    Q_PROPERTY(bool isProxyPortImmutable READ isProxyPortImmutable CONSTANT)
    /**
      Get The port number of the proxy
    */
    int proxyPort() const
    {
      return mProxyPort;
    }

    /**
      Is The port number of the proxy Immutable
    */
    bool isProxyPortImmutable() const
    {
      return isImmutable( QStringLiteral( "ProxyPort" ) );
    }

    /**
      Get The port number of the proxy default value
    */
    int defaultProxyPortValue() const
    {
        return defaultProxyPortValue_helper();
    }

    /**
      Set The user of the proxy
    */
    void setProxyUser( const QString & v )
    {
      if (v != mProxyUser && !isProxyUserImmutable()) {
        mProxyUser = v;
        Q_EMIT ProxyUserChanged();
      }
    }

    Q_PROPERTY(QString proxyUser READ proxyUser WRITE setProxyUser NOTIFY ProxyUserChanged)
    Q_PROPERTY(bool isProxyUserImmutable READ isProxyUserImmutable CONSTANT)
    /**
      Get The user of the proxy
    */
    QString proxyUser() const
    {
      return mProxyUser;
    }

    /**
      Is The user of the proxy Immutable
    */
    bool isProxyUserImmutable() const
    {
      return isImmutable( QStringLiteral( "ProxyUser" ) );
    }

    /**
      Set The password of the proxy
    */
    void setProxyPassword( const QString & v )
    {
      if (v != mProxyPassword && !isProxyPasswordImmutable()) {
        mProxyPassword = v;
        Q_EMIT ProxyPasswordChanged();
      }
    }

    Q_PROPERTY(QString proxyPassword READ proxyPassword WRITE setProxyPassword NOTIFY ProxyPasswordChanged)
    Q_PROPERTY(bool isProxyPasswordImmutable READ isProxyPasswordImmutable CONSTANT)
    /**
      Get The password of the proxy
    */
    QString proxyPassword() const
    {
      return mProxyPassword;
    }

    /**
      Is The password of the proxy Immutable
    */
    bool isProxyPasswordImmutable() const
    {
      return isImmutable( QStringLiteral( "ProxyPassword" ) );
    }


    enum {
      signalProxyTypeChanged = 1,
      signalProxyHostChanged = 2,
      signalProxyPortChanged = 3,
      signalProxyUserChanged = 4,
      signalProxyPasswordChanged = 5
    };

  Q_SIGNALS:
    void ProxyTypeChanged();

    void ProxyHostChanged();

    void ProxyPortChanged();

    void ProxyUserChanged();

    void ProxyPasswordChanged();

  private:
    void itemChanged(quint64 signalFlag);

  protected:

    // NetworkProxy
    int mProxyType;
    int defaultProxyTypeValue_helper() const;
    QString mProxyHost;
    QString defaultProxyHostValue_helper() const;
    int mProxyPort;
    int defaultProxyPortValue_helper() const;
    QString mProxyUser;
    QString defaultProxyUserValue_helper() const;
    QString mProxyPassword;
    QString defaultProxyPasswordValue_helper() const;

  private:
};

#endif

